#include <Eigen/Core>
#include <ur5/utilities.h>
#include <me530646_lab1/lab1.h>
#include <me530646_lab2/lab2.h>
#include <me530646_lab3/lab3.h>

int main(int argc, char **argv){
	ros::init(argc,argv,"lab3");
	ros::NodeHandle n;
	UR5 robot = UR5(n);
	double q1[] = {1,1,2,3,1,0};
	//double q1[] = {0.5,0.3,0.9,1.3,1.2,1};
	//double q1[] = {3,2,1.5,2.5,1.3,1.2};
	robot.plotfwd(q1);

	Eigen::VectorXf jointspar(6);
	RvizPlotter p = RvizPlotter(n); 
	robot.plotframes(p, q1);     
	Eigen::MatrixXf jposition(6,3);
	Eigen::Matrix4f homotransfbg(4,4);
	jointspar<<q1[0],q1[1],q1[2],q1[3],q1[4],q1[5];
	homotransfbg=robot.fwd(q1);
	jposition=robot.jointsposition(q1);
	std::cout<<"the joint angles: "<<'\n'<<jointspar<<'\n'<<std::endl;
	std::cout<<"the homotransf between base and effector: "<<'\n'<<homotransfbg<<'\n'<<std::endl;  
	std::cout<<"the joints positions: "<<'\n'<<jposition<<'\n'<<std::endl;    

}                   
     
          
