#include <Eigen/Core>
#include <ur5/utilities.h>
#include <me530646_lab1/lab1.h>
#include <me530646_lab2/lab2.h>
#include <me530646_lab3/lab3.h>
#include <me530646_lab4/lab4.h>
#include <ur_kinematics/ur_kin.h>

int main(int argc, char **argv){
	ros::init(argc,argv,"lab3");
	ros::NodeHandle n;
	UR5 robot = UR5(n);

	//How to calculate the trace of a matrix
	Eigen::MatrixXf M= Eigen::MatrixXf::Random(4,4);
	double trace = M.trace();

	//How to call inverse
	double q[6] = {0,0,0,0,0,0};
	double *q_sol[8];
	for(int i = 0; i < 8; i++)
	{
		q_sol[i] = new double[6];
	}
	//int num_sol = inverse(UR5::fwd(q),q_sol);

	

	double qfoward[6]={3.3,3.8,3.5,5.1,6.1,0.5};     //to see the output of Inverse Kinematics     
	int num_sol=0;
	int i,j,k;
	num_sol = inverse(UR5::fwd(qfoward),q_sol);
	std::cout<<"the number of solutions: "<<num_sol<<'\n'<<std::endl; 
	for (i=0;i<num_sol;i++){
	  std::cout<<"Configuration"<<i+1<<":  "<<std::endl;
	  for(j=0;j<6;j++)
	    std::cout<<q_sol[i][j]<<'\n'<<std::endl;
	  std::cout<<'\n'<<std::endl;      
	}








	double theta0[6]={0};     //three thetas two delthetas to evaluate the Jacobian matrix    
	double theta1[6]={0};  
	double theta2[6]={0};
	double deltheta0[6]={0.01,0.02,0.03,0.07,0.08,0.09};
	double deltheta1[6]={0.1,0.12,0.13,0.125,0.113,0.112};
	theta0[0]=3;
	theta1[0]=0.5;
	theta2[0]=6.15;
	for (j=1;j<6;j++)     //to choose the three thetas         
	  theta0[j]=theta0[j-1]+0.52;
	for (j=1;j<6;j++)
	  theta1[j]=theta1[j-1]+1.2;   
	for (j=1;j<6;j++)
	  theta2[j]=theta2[j-1]-0.9;	
	double thetaplus[6]={0};

	Eigen::Matrix4f homotransf0(4,4),homotransf00(4,4),homotransf01(4,4);   
	Eigen::MatrixXf J0(6,6);
	Eigen::Vector3f a0(3,1), b0(3,1);     //a is the difference between the two coordinates     
	Eigen::Matrix3f A0(3,3), B0(3,3),C0(3,3),D0(3,3);     
	Eigen::VectorXf Edeltheta0(6,1),Edeltheta1(6,1);      
	double normAB0;     

	Eigen::Matrix4f homotransf1(4,4),homotransf10(4,4),homotransf11(4,4); 
	Eigen::MatrixXf J1(6,6);
	Eigen::Vector3f a1(3,1), b1(3,1);
	Eigen::Matrix3f A1(3,3), B1(3,3),C1(3,3),D1(3,3);     
	double normAB1;     

	Eigen::Matrix4f homotransf2(4,4),homotransf20(4,4),homotransf21(4,4); 
	Eigen::MatrixXf J2(6,6);
	Eigen::Vector3f a2(3,1), b2(3,1);
	Eigen::Matrix3f A2(3,3), B2(3,3),C2(3,3),D2(3,3);      
	double normAB2;

	homotransf0= UR5::fwd(theta0);     //Question 3 (1)     
	for (j=0;j<6;j++)
	  thetaplus[j]=theta0[j]+deltheta0[j];          
	homotransf00=UR5::fwd(thetaplus); 
    
	J0=J(theta0);     //Question 3 (2)

	a0=homotransf0.block<3,1>(0,3)-homotransf00.block<3,1>(0,3);     //Question 3 (3)         
	for (j=0;j<6;j++){
	  Edeltheta0(j)=deltheta0[j];  
	}  
	b0=J0.block<3,6>(0,0)*Edeltheta0;     
	     	
	C0=homotransf00.block<3,3>(0,0);      //Question 3 (4)
	D0=homotransf0.block<3,3>(0,0); 
	A0=(C0-D0)*(D0.transpose());     
	B0=skew3(J0.block<3,6>(3,0)*Edeltheta0);
	C0=A0-B0;
	normAB0=((C0.transpose())*C0).trace();     

	std::cout<<"the difference between positions1: "<<'\n'<<a0-b0<<'\n'<<std::endl; 
	std::cout<<"the difference between orientations1: "<<'\n'<<C0<<'\n'<<normAB0<<'\n'<<std::endl; 





	homotransf1= UR5::fwd(theta1);     //Question 3 (1)     
	for (j=0;j<6;j++)
	  thetaplus[j]=theta1[j]+deltheta0[j];          
	homotransf10=UR5::fwd(thetaplus); 
    
	J1=J(theta1);     //Question 3 (2)

	a1=homotransf1.block<3,1>(0,3)-homotransf10.block<3,1>(0,3);     //Question 3 (3)         
	for (j=0;j<6;j++){
	  Edeltheta0(j)=deltheta0[j];  
	}  
	b1=J1.block<3,6>(0,0)*Edeltheta0;     
	     	
	C1=homotransf10.block<3,3>(0,0);      //Question 3 (4)
	D1=homotransf1.block<3,3>(0,0); 
	A1=(C1-D1)*(D1.transpose());     
	B1=skew3(J1.block<3,6>(3,0)*Edeltheta0);
	C1=A1-B1;
	normAB1=((C1.transpose())*C1).trace();     


	std::cout<<"the difference between positions2: "<<'\n'<<a1-b1<<'\n'<<std::endl; 
	std::cout<<"the difference between orientations2: "<<'\n'<<C1<<'\n'<<normAB1<<'\n'<<std::endl;




	
	homotransf2= UR5::fwd(theta2);     //Question 3 (1)     
	for (j=0;j<6;j++)
	  thetaplus[j]=theta2[j]+deltheta0[j];          
	homotransf20=UR5::fwd(thetaplus); 
    
	J2=J(theta2);     //Question 3 (2)

	a2=homotransf2.block<3,1>(0,3)-homotransf20.block<3,1>(0,3);     //Question 3 (3)         
	for (j=0;j<6;j++){
	  Edeltheta0(j)=deltheta0[j];  
	}  
	b2=J2.block<3,6>(0,0)*Edeltheta0;     
	     	
	C2=homotransf20.block<3,3>(0,0);      //Question 3 (4)
	D2=homotransf2.block<3,3>(0,0); 
	A2=(C2-D2)*(D2.transpose());     
	B2=skew3(J2.block<3,6>(3,0)*Edeltheta0);
	C2=A2-B2;
	normAB2=((C2.transpose())*C2).trace();     


	std::cout<<"the difference between positions3: "<<'\n'<<a2-b2<<'\n'<<std::endl; 
	std::cout<<"the difference between orientations3: "<<'\n'<<C2<<'\n'<<normAB2<<'\n'<<std::endl;


	//Question 4  According to the tests above, the accuracy is around 0.0001 to 0.001, for      
	//different angles and increasing or decreasing angles chosen here          
    
}     


